//Tennis applet  2001 by Johannes Wallroth - www.programming.de

import java.applet.*;
import java.awt.*;

class Tennisball
{	
	
	double x, y, oldx, oldy, xinc, yinc, v=2.0;
	int i,e,west,north,east,south,ry,rs,score,rx;	
	int choice, zone;
	AudioClip ballout;
	boolean running,toggle,enough;Color ballcolor;
	Tennis t;
	Color bgColor = Color.black;
	
	public Tennisball(int w, int n, int e, int s, AudioClip bo,Tennis t)
	{
		west=w;
		east=e;
		south=s;
		north=n;
		ballout = bo;
		this.t = t;	
		xinc=1.7*v;
		yinc=0.7*v;
	}	

	public void getRacketPosition(int racket_y)
	{
		ry=racket_y;		
		rs=ry;
	}

	public void newBall()
	{	
		ballcolor=Color.yellow;
		
		x=20;

		y=(int)(Math.random()*100+50);		

		int angle=(int)(Math.random()*8+1);
				
		if(angle==1)yinc=-0.7*v;
		if(angle==2)yinc=-0.5*v;
		if(angle==3)yinc=-0.4*v;
		if(angle==4)yinc=-0.3*v;
		if(angle==5)yinc=0.3*v;
		if(angle==6)yinc=0.4*v;
		if(angle==7)yinc=0.5*v;
		if(angle==8)yinc=0.7*v;
			
		toggle=false;
		running=true;
		enough=false;
		e=0;		
	}		
	
	public void move()
	{
		if(running)
		{	
			if(!toggle)
			{
				oldx=x;
				oldy=y;
				x+=xinc*v;
				y+=yinc*v;	
			}

			if(x<west && xinc<0)
			{
				int angle=(int)(Math.random()*8+1);
				
				if(angle==1)yinc=-0.7*v;
				if(angle==2)yinc=-0.5*v;
				if(angle==3)yinc=-0.4*v;
				if(angle==4)yinc=-0.3*v;
				if(angle==5)yinc=0.3*v;
				if(angle==6)yinc=0.4*v;
				if(angle==7)yinc=0.5*v;
				if(angle==8)yinc=0.7*v;

    			xinc=-xinc;	
				t.playClick();
			}

			else if(x>east-10)
			{
				x=east-10;
				toggle=true;
				running=false;
				score++;
				t.playBallout();
			}

			else if(y<north || y>south)
			{					
    			if(y<north&&yinc<0)
					yinc=-yinc;							

				if(y>south&&yinc>0)
					yinc=-yinc;	
				
				t.playClick();
			}			

			else if(x>425 && xinc>0 && y>ry && y<rs+25)
			{
				if(y<ry+3)zone=1;
				else if(y>=ry+3&&y<ry+6)zone=2;
				else if(y>=ry+6&&y<ry+9)zone=3;
				else if(y>=ry+9&&y<ry+12)zone=4;
				else if(y>=ry+12&&y<ry+15)zone=5;
				else if(y>=ry+15&&y<ry+18)zone=6;
				else if(y>=ry+18&&y<ry+21)zone=7;
				else if(y>=ry+21)zone=8;

				if(zone==1)yinc=-0.7*v;
				if(zone==2)yinc=-0.5*v;
				if(zone==3)yinc=-0.4*v;
				if(zone==4)yinc=-0.3*v;
				if(zone==5)yinc=0.3*v;
				if(zone==6)yinc=0.4*v;
				if(zone==7)yinc=0.5*v;
				if(zone==8)yinc=0.7*v;

				xinc=-xinc;
				
				t.playClick();
			}						
		}		
	}

	public void toggle()
	{					
				int i=t.j;

				if(!enough)
				{
					if(i>-1&&i<11)ballcolor=Color.yellow;
					if(i>10&&i<20){ballcolor=bgColor;e++;}	
				}

				if (e>35){ballcolor=bgColor;enough=true;}			
	}

	public void paint(Graphics g)
	{		
		if(toggle)toggle();		

		g.setColor(ballcolor);
		g.fillOval((int)x,(int)y,10,10);		
	}
}


public class Tennis extends Applet implements Runnable{        
        
        private Image Buffer;
        private Graphics gBuffer;
		Thread runner;
		int x,y,rx,ry,w,h,score,count,i,j;			
		Tennisball ball;			
		Color bgColor = Color.black;
		Color fgColor = Color.blue;
		boolean drag,click,eraseRect,erased,eraseGoalArea,g_a_erased;
		AudioClip start,ballout,clicksound;
		int framewidth, frameheight;int v;//v=velocity	
		Font font1 = new Font("Helvetica", Font.BOLD,60);		
		Font font2 = new Font("Dialog", Font.PLAIN,8);
		Font font3 = new Font("Helvetica", Font.PLAIN,26);
		double inc;

		public int score(int s)
		{			
			score=ball.score;				
			return score;
		}		

        public void update(Graphics g)
		{
               paint(g);
        }

        public void init() 
		{

                Buffer=createImage(size().width,size().height);
                gBuffer=Buffer.getGraphics();   
				framewidth=size().width;
				frameheight=size().height;	
				try
				{
					start=getAudioClip(getCodeBase(),"start.au");			
					ballout=getAudioClip(getCodeBase(),"ballout.au");
					clicksound=getAudioClip(getCodeBase(),"click.au");
				}
				catch (Exception e){}
				
				rx=440; ry=80;
				w=10; h=30; 				
				
				ball = new Tennisball(5,15,framewidth-5,frameheight-25, ballout,this);
				
				gBuffer.setColor(bgColor);
				gBuffer.fillRect(0,0,framewidth,frameheight);				
								
				Frame BrowserFrame;
				Component ParentComponent;
				ParentComponent = getParent();
				while ( ParentComponent != null && 
				!(ParentComponent instanceof Frame)) 		      
				ParentComponent = ParentComponent.getParent();		
				BrowserFrame = (Frame) ParentComponent;		
				BrowserFrame.setCursor(Frame.N_RESIZE_CURSOR);
        }	

		public boolean mouseDown(Event evt,int x,int y)
		{
			click=true;
			
			if(!ball.running)
			{				
				ball.newBall();

				start.play();
				i=1;

				eraseGoalArea=true;
			}			

		return true;
		}		
		
		public boolean mouseMove(Event evt,int x,int y)
		{
			ry=y-h/2;

			if(ry<5)
				ry=5;
			if(ry>frameheight-5-h)
				ry=frameheight-5-h;
			
			ball.getRacketPosition(ry);	
			
			return true;
		}
		
		public void start()
		{
                if (runner == null) 
				{
                        runner = new Thread (this);
                        runner.start();
                }
        }

        public void stop()
		{
                if (runner != null) 
				{
                        runner.stop();
                        runner = null;
                }
        }

		public void playBallout()
		{
			ballout.play();			
		}	
		
		public void playClick()
		{
			clicksound.play();			
		}	

        public void run()
		{			
                while (true) 
				{
					Thread.currentThread().setPriority(Thread.MAX_PRIORITY);

					for(i=1;i<10000;i++)
					{
						if(i>=9999)i=10000;

						j++;if(j==20)j=0;

						if(ball.running)
							count=i/100;

						inc=(double)count/40;

						if(inc>1.5)inc=1.5;

						ball.v=2.0+inc;						
					
						ball.move();					

                       try {runner.sleep (15);}
					   catch (Exception e) { }
                       repaint();
					}					
				}   
		}
		
		public void intro()
		{
			int x=size().width/2-100, y=size().height/2-45;

			gBuffer.setColor(Color.lightGray);
			gBuffer.fill3DRect(x,y,201,91,true);
			gBuffer.draw3DRect(x+2,y+2,196,86,false);

			gBuffer.setFont(font3);
			gBuffer.setColor(Color.red);
			gBuffer.drawString("Extreme Tennis",x+10,y+30);
			gBuffer.setFont(font2);
			gBuffer.setColor(Color.blue);
			gBuffer.drawString(" 2001 by Johannes Wallroth",x+28,y+50);
			gBuffer.drawString("www.programming.de",x+49,y+62);
			gBuffer.setColor(Color.black);
			gBuffer.drawString("Click to launch ball!",x+55,y+80);				
		}
		
		public void drawBallAndRacket() 
		{
			//we redraw only those backround parts that are dirty
			gBuffer.setColor(bgColor);
			gBuffer.fillRect((int)ball.oldx-10,(int)ball.oldy-10,30,30);

			//score=score(score);
			gBuffer.setFont(font1);	

			gBuffer.setColor(bgColor);
			gBuffer.fillRect(10,10,85,57);		
			
			gBuffer.setColor(fgColor);
			gBuffer.drawString(count<10?"0"+count:""+count,20,60);			

			gBuffer.setColor(bgColor);
			gBuffer.fillRect(rx,5,w,size().height-10);

			//the racket
			gBuffer.setColor(Color.red);
			gBuffer.fillRect(rx,ry,w,h);			
			
			//the interrupted line
			gBuffer.setColor(fgColor);
			for(int i=13;i<frameheight-10;i+=20)
				gBuffer.fillRect(framewidth/2-20,i,4,13);

		    if(ball.running||ball.toggle)
				ball.paint(gBuffer);			
			
			if(click==false&&i<400)
				intro();
			else if(!erased)
				eraseRect=true;

			if(eraseRect)
			{
				eraseRect=false;
				erased=true;
				gBuffer.setColor(bgColor);
				gBuffer.fillRect(0,0,framewidth,frameheight);				
			}
			if(eraseGoalArea)
			{
				eraseGoalArea=false;				
				gBuffer.setColor(bgColor);
				gBuffer.fillRect(rx+15,6,48,189);				
			}
			
		}
		
        public void paint(Graphics g)
		{								
				g.drawImage (Buffer,0,0, this);				
				drawBallAndRacket();                 
        }
}  



