//Darts-Spiel
//Johannes Wallroth 1998

import java.applet.*;
import java.awt.*;

public class Darts extends Applet implements Runnable {
        int hx,hy,mx,my,howmany,j,k,l;
        Thread Animation;
        private Image Buffer;
		private Image hand;		
		Color ThisColor,NextColor;
        private Graphics gBuffer;
		AudioClip dartstart,klack;
		private boolean pressed,klicked,newgame,newgamepressed,
			messagerunner,timerstart,late;
		Hand h;		
		int relx[],rely[],score[],display[];
		Color c[];
		Color c1 = new Color(200,200,160);
		Color c2 = new Color(200,220,110);		
		Font a = new Font("Helvetica", Font.PLAIN,25);
		Font b = new Font("Dialog", Font.PLAIN,15);		
		Font fc = new Font("Dialog", Font.ITALIC,15);	

		public void init() {				

			c=new Color[6];
			c[0]=Color.red;c[1]=Color.yellow;c[2]=Color.cyan;
			c[3]=Color.pink;c[4]=Color.green;c[5]=Color.magenta;

			howmany=-1;			
					
			relx=new int[6];
			rely=new int[6];
			score=new int[6];
			display=new int[6];	

			for(int i=0;i<6;i++)
			relx[i]=rely[i]=-10;					

			
			Buffer=createImage(size().width,size().height);
            gBuffer=Buffer.getGraphics();			
			hand=loadImage("gif/hand.gif");
                
				NextColor=Color.red;
				h = new Hand(hand,this);
				h.getBoundings();			

                gBuffer.setColor(Color.lightGray);
                gBuffer.fillRect(0,0,size().width,size().height);
				
				try{
					dartstart=getAudioClip(getCodeBase(),"dartstart.au");
					klack=getAudioClip(getCodeBase(),"klack.au");				
				}
				catch (Exception e){}
        }	

		public Image loadImage(String imagename){
			Image image=getImage(getDocumentBase(),imagename);
			MediaTracker tracker=new MediaTracker(this);
			tracker.addImage(image,0);
			try{
				tracker.waitForID(0);
			}catch(InterruptedException e){}
			return image;
		}

        public void start() {
                if (Animation == null) {
                        Animation = new Thread (this);
                        Animation.start();
                }
        }
        public void stop() {
                if (Animation != null) {
                        Animation.stop();
                        Animation = null;
                }
        }

        public void run() {	
			
			l=100;

                while (true) {
					
					for (int i=0; i < 100 ;i++) {
						h.i=i;
						if(timerstart==true)

						l--;
						
						j++;

						if(messagerunner==true)
							k++;
						
						h.move();

                       try {
                               Animation.sleep (10);
                        } catch (Exception e) { }		
                        repaint();					}
                }
        }

        public void update(Graphics g) {
               paint(g);
        } 
		
		public void intro(){		
			
			gBuffer.setColor(c1);			
            gBuffer.fill3DRect(0,0,size().width,size().height,true);
			gBuffer.draw3DRect(5,5,size().width-10,size().height-10,true);	

			gBuffer.setColor(c2);
			gBuffer.fill3DRect(50,70,201,101,true);
			gBuffer.draw3DRect(52,72,196,96,true);

			gBuffer.setFont(a);
			gBuffer.setColor(Color.red);
			gBuffer.drawString("Darts",120,110);

			gBuffer.setFont(b);
			gBuffer.setColor(Color.blue);
			gBuffer.drawString(" J.Wallroth, Berlin 1998",78,140);			
			
		}

		public void message(){

			gBuffer.setFont(b);
			gBuffer.setColor(Color.blue);
			gBuffer.drawString("Klick and",130,230);
			gBuffer.setFont(fc);
			gBuffer.setColor(Color.red);
			gBuffer.drawString("hold Mouse Button pressed",67,245);
			gBuffer.setFont(b);
			gBuffer.setColor(Color.blue);
			gBuffer.drawString("to aim, then release it",90,260);
		}

		public void timer(){
			timerstart=true;
			
			if(l<0){
				pressed=newgamepressed=false;			

		if(newgame==true)klack.play();		
		
		if(newgame==true)howmany++;	
		
		relx[howmany-1]=h.hx-30;
		rely[howmany-1]=h.hy-95;
		
		int i=howmany-1;
		int xm=150;int ym=100;
		score[i]=(int)Math.sqrt((xm-relx[i])*(xm-relx[i])+(ym-rely[i])*(ym-rely[i]));			

		if(howmany>5){

			howmany=-1;
			newgame=false;
		}				
		
		late=true;
		
		repaint();
				

			}
		}

		public void drawBackground(){

			gBuffer.setColor(c1);//Hintergrund
            gBuffer.fill3DRect(0,0,size().width,size().height,true);
			gBuffer.draw3DRect(5,5,size().width-10,size().height-10,true);			
			gBuffer.draw3DRect(65,15,170,170,true);
			
			if(howmany<0){
			if(newgamepressed==false)
			gBuffer.fill3DRect(65,230,170,50,true);//Der NEW GAME Button
			else
				gBuffer.fill3DRect(65,230,170,50,false);

			gBuffer.setFont(a);
			gBuffer.setColor(Color.blue);
			gBuffer.drawString("NEW GAME",82,263);
			}
		
			if(pressed==false&&howmany<6&&newgame==true)
				drawNextDart();//Der nchste Pfeil

			if(pressed==true&&newgame==true){
			gBuffer.setColor(Color.yellow);//Der 'Timer'
			gBuffer.fillRect(20,20,30,200);
			gBuffer.setColor(Color.red);
			gBuffer.fillRect(20,l*2+20,30,200-l*2);
			gBuffer.setColor(Color.black);
			gBuffer.drawRect(20,20,30,200);
			}
		}

		public void circle(int xmiddle,int ymiddle,int diam,Color col){
			
			int x=xmiddle-diam/2;
			int y=ymiddle-diam/2;

			gBuffer.setColor(col);
                gBuffer.fillOval(x,y,diam,diam);
		}

		
		public void drawTarget() {
			int xm=150;int ym=100;//Mittelpunkt der Scheibe
			
				circle(xm,ym,152,Color.black);	
				circle(xm,ym,150,Color.white);	
				circle(xm,ym,135,Color.black);
				circle(xm,ym,120,Color.white);
				circle(xm,ym,105,Color.black);
				circle(xm,ym,90,Color.white);
				circle(xm,ym,75,Color.black);
				circle(xm,ym,60,Color.white);
				circle(xm,ym,45,Color.black);
				circle(xm,ym,30,Color.white);
				circle(xm,ym,15,Color.black);
				
		}

  public void drawHand() {	
	  
			if(newgame==true) h.paint(gBuffer);				
	}

  public boolean mouseDown(Event evt,int x,int y){		  
	  
		pressed=true;
		l=100;
		late=false;
		
		if(x>65&&x<235&&y>230&&y<280){//NEW GAME angeklickt
		 	newgamepressed=true;		
		}
		else newgamepressed=false;
		
		Color tc=ThisColor;
		Color nc=NextColor;		
		
		switch(howmany){
		case(0):{tc=c[0];nc=c[1];break;}
		case(1):{tc=c[1];nc=c[2];break;}
		case(2):{tc=c[2];nc=c[3];break;}
		case(3):{tc=c[3];nc=c[4];break;}
		case(4):{tc=c[4];nc=c[5];break;}
		case(5):{tc=c[5];nc=c[0];break;}
								}		
		
		ThisColor=tc;
		NextColor=nc;	
		
		repaint();
		return true;
	}

  public boolean mouseUp(Event evt,int x,int y){ 
	  
	  if(late==false){
	  
	    pressed=newgamepressed=false;
		boolean onbutton=false;

		if(j>100){
		if(howmany==-1&&x>65&&x<235&&y>230&&y<280){//NEW GAME angeklickt
			klicked=true;dartstart.play();
		  newgame=true;messagerunner=true;
		  onbutton=true;
			for(int i=0;i<6;i++)
				relx[i]=rely[i]=-30;
		}
		else onbutton=false;
		}

		if(onbutton==false&&newgame==true)klack.play();		
		
		if(newgame==true)howmany++;	
		
		relx[howmany-1]=h.hx-30;
		rely[howmany-1]=h.hy-95;

		
		int i=howmany-1;
		int xm=150;int ym=100;
		score[i]=(int)Math.sqrt((xm-relx[i])*(xm-relx[i])+(ym-rely[i])*(ym-rely[i]));			
			

		if(howmany>5){

			howmany=-1;
			newgame=false;
		}			
	  }
		
		repaint();
		return true;
	}

  public boolean mouseMove(Event evt,int x,int y){			
		mx=x;
		my=y;
		
		repaint();
		return true;
	}

public boolean mouseDrag(Event evt,int x,int y){			
		mx=x;
		my=y;
		
		repaint();
		return true;
	}

public void drawScore(int i,int x,int y){

	if(display[i]>9)x-=4;
	gBuffer.setFont(b);
			gBuffer.setColor(Color.black);
			gBuffer.drawString(""+display[i],x,y);
}


public void calculateScore(){	

	int j=30;int z=0;int sum=0;
	if(howmany==-1&&klicked==true)z=6;
	else z=howmany;
	
			for(int i=0;i<6;i++){

				if(score[i]<8)display[i]=10;
				if(score[i]<15&&score[i]>7)display[i]=9;
				if(score[i]<23&&score[i]>14)display[i]=8;
				if(score[i]<30&&score[i]>22)display[i]=7;
				if(score[i]<38&&score[i]>29)display[i]=6;
				if(score[i]<45&&score[i]>37)display[i]=5;
				if(score[i]<53&&score[i]>44)display[i]=4;
				if(score[i]<60&&score[i]>52)display[i]=3;
				if(score[i]<68&&score[i]>59)display[i]=2;
				if(score[i]<75&&score[i]>67)display[i]=1;
				if(score[i]>74)display[i]=0;

	sum=display[0]+display[1]+display[2]+display[3]+display[4]+display[5];
			
			}
			
			if(z>0){circle(265,28,25,c[0]);drawScore(0,262,34);}
			if(z>1){circle(265,57,25,c[1]);drawScore(1,262,63);}
			if(z>2){circle(265,86,25,c[2]);drawScore(2,262,92);}
			if(z>3){circle(265,115,25,c[3]);drawScore(3,262,121);}
			if(z>4){circle(265,144,25,c[4]);drawScore(4,262,150);}
			if(z>5){circle(265,173,25,c[5]);drawScore(5,262,179);

			gBuffer.setFont(b);
			gBuffer.setColor(Color.blue);
			gBuffer.drawString("SCORE:",10,30);
			gBuffer.setColor(Color.yellow);
			gBuffer.drawString("GAME",15,140);
			gBuffer.drawString("OVER",15,155);
			gBuffer.setFont(a);
			gBuffer.setColor(Color.red);
			gBuffer.drawString(""+sum,20,60);
			}



			gBuffer.setColor(Color.black);
		gBuffer.drawArc(253,16,25,25,45,180);
		gBuffer.drawArc(253,45,25,25,45,180);
		gBuffer.drawArc(253,74,25,25,45,180);
		gBuffer.drawArc(253,103,25,25,45,180);
		gBuffer.drawArc(253,132,25,25,45,180);
		gBuffer.drawArc(253,161,25,25,45,180);

		gBuffer.setColor(Color.white);
		gBuffer.drawArc(253,16,25,25,225,180);
		gBuffer.drawArc(253,45,25,25,225,180);
		gBuffer.drawArc(253,74,25,25,225,180);
		gBuffer.drawArc(253,103,25,25,225,180);
		gBuffer.drawArc(253,132,25,25,225,180);
		gBuffer.drawArc(253,161,25,25,225,180);			
	
}


public void drawDartInHand(){
	hx=h.hx-30;//Der Punkt an dem der Pfeil erscheint
	hy=h.hy-95;
	
	circle(hx,hy,10,ThisColor);
	gBuffer.setColor(ThisColor);
	gBuffer.fillRect(hx-10,hy,22,2);
	gBuffer.fillRect(hx,hy-10,2,22);

	timer();
	
}

public void drawHitOnTarget(){	
	
	for(int i=0;i<6;i++){		
	circle(relx[i],rely[i],10,c[i]);
	gBuffer.fillRect(relx[i]-10,rely[i],22,2);
	gBuffer.fillRect(relx[i],rely[i]-10,2,22);	
	}	
}

public void drawNextDart(){
	
	gBuffer.setColor(NextColor);
	gBuffer.fillOval(17,35,35,50);
	gBuffer.fillRect(30,75,10,50);
	gBuffer.setColor(Color.white);
	gBuffer.fillRect(30,120,10,25);
	gBuffer.fillRect(31,145,8,5);
	gBuffer.setColor(Color.black);
	gBuffer.fillRect(34,150,2,15);
	gBuffer.drawLine(30,125,39,125);
	gBuffer.drawLine(30,130,39,130);
	gBuffer.drawLine(30,135,39,135);
	gBuffer.drawLine(30,140,39,140);
}


        public void paint(Graphics g) {
				
				drawBackground();//Hintergrund			
				drawTarget();//Zielscheibe				
				drawHitOnTarget();//Treffer
				calculateScore();				
				if(howmany<6&&pressed==true)drawHand();//Hand
				if(pressed==true&&howmany<6&&newgame==true)drawDartInHand();//Pfeil in Hand
				if(klicked==false&&j<100)intro();
				if(klicked==true&&newgame==true&&k>0&&k<300)message();
					
                g.drawImage (Buffer,0,0, this);                
                
        }
} 

class Hand extends Applet{	
	
	int x,y,hx,hy,i,west,north,east,south;	
	Color myColor; boolean right,left,up,down;	
	public Image hand;	
	Darts d;

	
	public Hand(Image h,Darts d){
				
		hand=h;			
		this.d = d;		
		right=true;	
		up=true;		
	}
	
	public void getBoundings(){
		
		west=d.mx-50;
		east=d.mx+50;
		north=d.my-50;
		south=d.my+50;
	}
	public int rand(int multi){
			double randomnumber = Math.random() * multi;
					int number = (int)randomnumber;
					return number+1;
		}	

	public void left(){x-=2;right=false;}
	public void right(){x+=2;left=false;}
	public void up(){y-=2;down=false;}
	public void down(){y+=2;up=false;}
	
	public void move(){	
		int rand=rand(4);
		
		if(right==true&&rand==1){right();if(x>east)left=true;}
		if(left==true&&rand==2){left();if(x<west)right=true;}
		if(up==true&&rand==3){up();if(y<north)down=true;}
		if(down==true&&rand==4){down();if(y>south)up=true;}
		
	}	

	public void paint(Graphics g){
				
		hx=d.mx+x;//Tatschliche Position der Hand
		hy=d.my+y;

		g.drawImage(hand,hx-50,hy-120,this);
		
		
	}
}
